--- /dev/null	2012-08-18 10:37:11.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp/dccp_tpi.c	2012-08-18 10:37:11.357947486 +0000
@@ -0,0 +1,434 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Functions related to TPI.
+ */
+
+#include <sys/types.h>
+#include <sys/stream.h>
+#include <sys/strsun.h>
+#include <sys/strsubr.h>
+#include <sys/stropts.h>
+#include <sys/strlog.h>
+#define _SUN_TPI_VERSION 2
+#include <sys/tihdr.h>
+#include <sys/suntpi.h>
+#include <sys/xti_inet.h>
+#include <sys/squeue_impl.h>
+#include <sys/squeue.h>
+#include <sys/tsol/tnet.h>
+
+#include <inet/common.h>
+#include <inet/dccp_impl.h>
+#include <inet/ip.h>
+#include <inet/proto_set.h>
+
+#include <sys/cmn_err.h>
+
+
+/*
+ * This file contains functions related to the TPI interface.
+ */
+
+/*
+ * XXX
+ */
+static void
+dccp_copy_info(struct T_info_ack *tia, dccp_t *dccp)
+{
+	conn_t		*connp = dccp->dccp_connp;
+	dccp_stack_t	*dccps = dccp->dccp_dccps;
+	extern struct T_info_ack dccp_g_t_info_ack;
+	extern struct T_info_ack dccp_g_t_info_ack_v6;
+
+	if (connp->conn_family == AF_INET6) {
+		*tia = dccp_g_t_info_ack_v6;
+	} else {
+		*tia = dccp_g_t_info_ack;
+	}
+
+	/* XXX */
+}
+
+/*
+ * XXX
+ */
+void
+dccp_do_capability_ack(dccp_t *dccp, struct T_capability_ack *tcap,
+    t_uscalar_t cap_bits1)
+{
+	tcap->CAP_bits1 = 0;
+
+	if (cap_bits1 & TC1_INFO) {
+		dccp_copy_info(&tcap->INFO_ack, dccp);
+		tcap->CAP_bits1 |= TC1_INFO;
+	}
+
+	if (cap_bits1 & TC1_ACCEPTOR_ID) {
+		tcap->ACCEPTOR_id = dccp->dccp_acceptor_id;
+		tcap->CAP_bits1 |= TC1_ACCEPTOR_ID;
+	}
+}
+
+/*
+ * This routine responds to T_CAPABILITY_REQ messages.
+ */
+void
+dccp_capability_req(dccp_t *dccp, mblk_t *mp)
+{
+	struct T_capability_ack	*tcap;
+	t_uscalar_t		cap_bits1;
+
+	if (MBLKL(mp) < sizeof (struct T_capability_req)) {
+		freemsg(mp);
+		return;
+	}
+
+	cap_bits1 = ((struct T_capability_req *)mp->b_rptr)->CAP_bits1;
+
+	mp = tpi_ack_alloc(mp, sizeof (struct T_capability_ack),
+	    mp->b_datap->db_type, T_CAPABILITY_ACK);
+	if (mp == NULL) {
+		return;
+	}
+
+	tcap = (struct T_capability_ack *)mp->b_rptr;
+	dccp_do_capability_ack(dccp, tcap, cap_bits1);
+
+	putnext(dccp->dccp_connp->conn_rq, mp);
+}
+
+/*
+ * This routine responds to T_INFO_REQ messages.
+ */
+void
+dccp_info_req(dccp_t *dccp, mblk_t *mp)
+{
+	mp = tpi_ack_alloc(mp, sizeof (struct T_info_ack), M_PCPROTO,
+	    T_INFO_ACK);
+	if (mp == NULL) {
+		dccp_err_ack(dccp, mp, TSYSERR, ENOMEM);
+		return;
+	}
+
+	dccp_copy_info((struct T_info_ack *)mp->b_rptr, dccp);
+	putnext(dccp->dccp_connp->conn_rq, mp);
+}
+
+/*
+ * This routine responds to T_ADDR_REQ messages.
+ */
+void
+dccp_addr_req(dccp_t *dccp, mblk_t *mp)
+{
+	conn_t	*connp = dccp->dccp_connp;
+	mblk_t	*ackmp;
+	uint_t	addrlen;
+	struct sockaddr		*sa;
+	struct T_addr_ack	*taa;
+
+	/* XXX */
+}
+
+/*
+ * Helper function to generate TPI errors acks.
+ */
+void
+dccp_err_ack(dccp_t *dccp, mblk_t *mp, int t_error, int sys_error)
+{
+	if ((mp = mi_tpi_err_ack_alloc(mp, t_error, sys_error)) != NULL) {
+		putnext(dccp->dccp_connp->conn_rq, mp);
+	}
+}
+
+void
+dccp_tpi_connect(dccp_t *dccp, mblk_t *mp)
+{
+	conn_t			*connp = dccp->dccp_connp;
+	queue_t			*q = connp->conn_wq;
+	struct sockaddr		*sa;
+	struct T_conn_req	*tcr;
+	sin_t			*sin;
+	sin6_t			*sin6;
+	cred_t			*cr;
+	pid_t			cpid;
+	socklen_t		len;
+	int			error;
+
+	cmn_err(CE_NOTE, "dccp_tpi.c: dccp_tpi_connect");
+
+	cr = msg_getcred(mp, &cpid);
+	ASSERT(cr != NULL);
+	if (cr == NULL) {
+		dccp_err_ack(dccp, mp, TSYSERR, EINVAL);
+		return;
+	}
+
+	tcr = (struct T_conn_req *)mp->b_rptr;
+
+	ASSERT((uintptr_t)(mp->b_wptr - mp->b_rptr) <= (uintptr_t)INT_MAX);
+	if ((mp->b_wptr - mp->b_rptr) < sizeof (*tcr)) {
+		dccp_err_ack(dccp, mp, TPROTO, 0);
+		return;
+	}
+
+	error = proto_verify_ip_addr(connp->conn_family, sa, len);
+	if (error != 0) {
+		dccp_err_ack(dccp, mp, TSYSERR, 0);
+		return;
+	}
+
+	error = dccp_do_connect(dccp->dccp_connp, sa, len, cr, cpid);
+	if (error < 0) {
+		mp = mi_tpi_err_ack_alloc(mp, -error, 0);
+	} else if (error > 0) {
+		mp = mi_tpi_err_ack_alloc(mp, TSYSERR, error);
+	} else {
+		mp = mi_tpi_ok_ack_alloc(mp);
+	}
+}
+
+int
+dccp_tpi_close(queue_t *q, int flags)
+{
+	conn_t	*connp;
+
+	ASSERT(WR(q)->q_next == NULL);
+
+	connp = Q_TO_CONN(q);
+
+	dccp_close_common(connp, flags);
+
+	qprocsoff(q);
+	inet_minor_free(connp->conn_minor_arena, connp->conn_dev);
+
+	return (0);
+}
+
+int
+dccp_tpi_close_accept(queue_t *q)
+{
+	vmem_t	*minor_arena;
+	dev_t	conn_dev;
+
+	cmn_err(CE_NOTE, "dccp_tpi.c: dccp_tpi_close_accept");
+
+	return (0);
+}
+
+boolean_t
+dccp_conn_con(dccp_t *dccp, uchar_t *iphdr, mblk_t *idmp,
+    mblk_t **defermp, ip_recv_attr_t *ira)
+{
+	conn_t	*connp = dccp->dccp_connp;
+	sin_t	sin;
+	sin6_t	sin6;
+	mblk_t	*mp;
+	char	*optp = NULL;
+	int	optlen = 0;
+
+	cmn_err(CE_NOTE, "dccp_tpi.c: dccp_conn_con");
+
+	if (defermp != NULL) {
+		*defermp = NULL;
+	}
+
+	if (IPH_HDR_VERSION(iphdr) == IPV4_VERSION) {
+		/* Packet is IPv4 */
+		if (connp->conn_family == AF_INET) {
+			sin = sin_null;
+			sin.sin_addr.s_addr = connp->conn_faddr_v4;
+			sin.sin_port = connp->conn_fport;
+			sin.sin_family = AF_INET;
+			mp = mi_tpi_conn_con(NULL, (char *)&sin,
+			    (int)sizeof (sin_t), optp, optlen);
+		} else {
+			sin6 = sin6_null;
+			sin6.sin6_addr = connp->conn_faddr_v6;
+			sin6.sin6_port = connp->conn_fport;
+			sin6.sin6_family = AF_INET6;
+			mp = mi_tpi_conn_con(NULL, (char *)&sin6,
+			    (int)sizeof (sin6_t), optp, optlen);
+		}
+	} else {
+		ip6_t	*ip6h = (ip6_t *)iphdr;
+
+		ASSERT(IPH_HDR_VERSION(iphdr) == IPV6_VERSION);
+		ASSERT(connp->conn_family == AF_INET6);
+
+		sin6 = sin6_null;
+		sin6.sin6_addr = connp->conn_faddr_v6;
+		sin6.sin6_port = connp->conn_fport;
+		sin6.sin6_family = AF_INET6;
+		sin6.sin6_flowinfo = ip6h->ip6_vcf & ~IPV6_VERS_AND_FLOW_MASK;
+		mp = mi_tpi_conn_con(NULL, (char *)&sin6,
+		    (int)sizeof (sin6_t), optp, optlen);
+	}
+
+	if (!mp) {
+		return (B_FALSE);
+	}
+
+	mblk_copycred(mp, idmp);
+
+	if (defermp == NULL) {
+		if (IPCL_IS_NONSTR(connp)) {
+			cmn_err(CE_NOTE, "calling su_connected");
+			(*connp->conn_upcalls->su_connected)
+			    (connp->conn_upper_handle, dccp->dccp_connid,
+			    ira->ira_cred, ira->ira_cpid);
+			freemsg(mp);
+		} else {
+			if (ira->ira_cred != NULL) {
+				/* So that getpeerucred works for TPI sockfs */
+				mblk_setcred(mp, ira->ira_cred, ira->ira_cpid);
+			}
+			putnext(connp->conn_rq, mp);
+		}
+	} else {
+		*defermp = mp;
+	}
+
+	/* XXX */
+	return (B_TRUE);
+}
+
+/*
+ * Routine to get the values of options.
+ */
+int
+dccp_tpi_opt_get(queue_t *q, int level, int name, uchar_t *ptr)
+{
+	return (dccp_opt_get(Q_TO_CONN(q), level, name, ptr));
+}
+
+/*
+ * Routine to set the values of options.
+ */
+/* ARGSUSED */
+int
+dccp_tpi_opt_set(queue_t *q, uint_t optset_context, int level, int name,
+    uint_t inlen, uchar_t *invalp, uint_t *outlenp, uchar_t *outvalp,
+    void *thisdg_attrs, cred_t *cr)
+{
+	conn_t	*connp =  Q_TO_CONN(q);
+
+	return (dccp_opt_set(connp, optset_context, level, name, inlen, invalp,
+	    outlenp, outvalp, thisdg_attrs, cr));
+}
+
+void
+dccp_tpi_accept(queue_t *q, mblk_t *mp)
+{
+	struct T_ok_ack		*ok;
+	struct T_conn_res	*conn_res;
+	conn_t			*econnp;
+	dccp_t			*eager;
+	dccp_t			*listener;
+	queue_t			*rq = RD(q);
+	mblk_t			*discon_mp;
+	cred_t			*cr;
+
+	cmn_err(CE_NOTE, "dccp_tpi.c: dccp_tpi_accept");
+
+	ASSERT(DB_TYPE(mp) == M_PROTO);
+
+	cr = msg_getcred(mp, NULL);
+	ASSERT(cr != NULL);
+	if (cr == NULL) {
+		mp = mi_tpi_err_ack_alloc(mp, TSYSERR, EINVAL);
+		if (mp != NULL) {
+			putnext(rq, mp);
+		}
+		return;
+	}
+
+	conn_res = (struct T_conn_res *)mp->b_rptr;
+	ASSERT((uintptr_t)(mp->b_wptr - mp->b_rptr) <= (uintptr_t)INT_MAX);
+	if ((mp->b_wptr - mp->b_rptr) < sizeof (struct T_conn_res)) {
+		mp = mi_tpi_err_ack_alloc(mp, TPROTO, 0);
+		if (mp != NULL) {
+			putnext(rq, mp);
+		}
+		return;
+	}
+
+	switch (conn_res->PRIM_type) {
+	case O_T_CONN_RES:
+	case T_CONN_RES:
+		putnext(rq, mp);
+		return;
+	default:
+		mp = mi_tpi_err_ack_alloc(mp, TNOTSUPPORT, 0);
+		if (mp != NULL) {
+			putnext(rq, mp);
+		}
+		return;
+	}
+}
+
+static void
+dccp_accept_swap(dccp_t *listener, dccp_t *acceptor, dccp_t *eager)
+{
+	conn_t	*econnp;
+	conn_t	*aconnp;
+}
+
+/*
+ * This runs at the tail end of accept processing on the squeue of the
+ * new connection.
+ */
+static void
+dccp_accept_finish(void *arg, mblk_t *mp, void *arg2, ip_recv_attr_t *dummy)
+{
+	conn_t		*connp = (conn_t *)arg;
+	dccp_t		*dccp = connp->conn_dccp;
+	dccp_stack_t	*dccps = dccp->dccp_dccps;
+	queue_t		*q = connp->conn_rq;
+	struct stroptions	*stropt;
+	struct sock_proto_props	sopp;
+
+	/* Should never be called for non-STREAMS sockets */
+	ASSERT(!IPCL_IS_NONSTR(connp));
+
+	/* We should just receive a single mblk that fits a T_discon_ind */
+	ASSERT(mp->b_cont == NULL);
+
+	/* XXX */
+
+	dccp_get_proto_props(dccp, &sopp);
+
+	ASSERT(DB_REF(mp) == 1);
+	ASSERT(MBLKSIZE(mp) >= sizeof (struct stroptions));
+
+	DB_TYPE(mp) = M_SETOPTS;
+
+	/* XXX */
+
+	dccp->dccp_hard_binding = B_FALSE;
+
+	if (connp->conn_keepalive) {
+		dccp->dccp_ka_last_intrvl = 0;
+		dccp->dccp_ka_tid = DCCP_TIMER(dccp, dccp_keepalive_timer,
+		    dccp->dccp_ka_interval);
+	}
+}
--- /dev/null	2012-08-18 10:37:11.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp/dccp_tunables.c	2012-08-18 10:37:11.523731195 +0000
@@ -0,0 +1,87 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner.  All rights reserved.
+ */
+
+/*
+ * This file contains tunable properties for DCCP.
+ */
+#include <inet/ip.h>
+#include <inet/ip6.h>
+#include <inet/dccp_impl.h>
+#include <sys/sunddi.h>
+
+mod_prop_info_t dccp_propinfo_tbl[] = {
+	/* tunable - 0 */
+	{ "smallest_nonpriv_port", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {1024, (32 * 1024), 1024}, {1024} },
+
+	{ "smallest_anon_port", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {1024, ULP_MAX_PORT, 32*1024}, {32*1024} },
+
+	{ "largest_anon_port", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {1024, ULP_MAX_PORT, ULP_MAX_PORT}, {ULP_MAX_PORT} },
+
+	{ "_xmit_lowat", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {0, (1<<30), DCCP_XMIT_LOWATER},
+	    {DCCP_XMIT_LOWATER} },
+
+	{ "_debug", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {0, 10, 0}, {0} },
+
+	{ "_rst_sent_rate_enabled", MOD_PROTO_DCCP,
+	    mod_set_boolean, mod_get_boolean,
+	    {B_TRUE}, {B_TRUE} },
+
+	{ "_rst_sent_rate", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {0, UINT32_MAX, 40}, {40} },
+
+	{ "_ip_abort_cinterval", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {1*SECONDS, UINT32_MAX, 3*MINUTES}, {3*MINUTES} },
+
+	{ "_ip_abort_linterval", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {1*SECONDS, UINT32_MAX, 3*MINUTES}, {3*MINUTES} },
+
+	{ "_ip_abort_interval", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {500*MS, UINT32_MAX, 5*MINUTES}, {5*MINUTES} },
+
+	/* tunable - 10 */
+	{ "_ip_notify_cinterval", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {1*SECONDS, UINT32_MAX, 10*SECONDS}, {10*SECONDS} },
+
+	{ "_ip_notify_interval", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {500*MS, UINT32_MAX, 10*SECONDS}, {10*SECONDS} },
+
+	{ "_keepalive_interval", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {10*SECONDS, 10*DAYS, 2*HOURS}, {2*HOURS} },
+
+	{ "_keepalive_abort_interval", MOD_PROTO_DCCP,
+	    mod_set_uint32, mod_get_uint32,
+	    {0, UINT32_MAX, 8*MINUTES}, {8*MINUTES} },
+
+	{ NULL, 0, NULL, NULL, {0}, {0} }
+};
+
+int dccp_propinfo_count = A_CNT(dccp_propinfo_tbl);
--- /dev/null	2012-08-18 10:37:11.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp/dccpddi.c	2012-08-18 10:37:11.742640611 +0000
@@ -0,0 +1,59 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner.  All rights reserved.
+ */
+
+#include <sys/types.h>
+#include <sys/conf.h>
+#include <sys/modctl.h>
+#include <inet/common.h>
+#include <inet/ip.h>
+#include <sys/strsubr.h>
+#include <sys/socketvar.h>
+#include <inet/dccp.h>
+#include <inet/dccp_impl.h>
+
+#define	INET_NAME	"dccp"
+#define	INET_MODDESC	"DCCP dummy STREAMS module"
+#define	INET_DEVDESC	"DCCP STREAMS driver"
+#define	INET_SOCKDESC	"DCCP socket module"
+#define	INET_MODSTRTAB	dummymodinfo
+#define	INET_DEVSTRTAB	dccpinfov4
+#define	INET_MODMTFLAGS	D_MP
+#define	INET_SOCK_PROTO_CREATE_FUNC	(*dccp_create)
+#define	INET_SOCK_PROTO_FB_FUNC		(*dccp_fallback)
+#define	INET_SOCK_FALLBACK_DEV_V4	"/dev/dccp"
+#define	INET_SOCK_FALLBACK_DEV_V6	"/dev/dccp6"
+#define	INET_DEVMINOR	0
+#define INET_MODMTFLAGS	D_MP
+#define	INET_DEVMTFLAGS (D_MP|_D_DIRECT)
+
+#include "../inetddi.c"
+
+int
+_init(void)
+{
+	return (mod_install(&modlinkage));
+}
+
+int
+_fini(void)
+{
+	return (mod_remove(&modlinkage));
+}
+
+int
+_info(struct modinfo *modinfop)
+{
+	return (mod_info(&modlinkage, modinfop));
+}
--- /dev/null	2012-08-18 10:37:11.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp_impl.h	2012-08-18 10:37:11.937118819 +0000
@@ -0,0 +1,379 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner. All rights reserved.
+ */
+
+#ifndef	_INET_DCCP_IMPL_H
+#define	_INET_DCCP_IMPL_H
+
+#include <sys/int_types.h>
+#include <sys/netstack.h>
+#include <sys/socket.h>
+#include <sys/socket_proto.h>
+#include <sys/clock_impl.h>
+
+#include <netinet/in.h>
+#include <netinet/ip6.h>
+#include <netinet/dccp.h>
+
+#include <inet/common.h>
+#include <inet/dccp.h>
+#include <inet/ip.h>
+#include <inet/ip6.h>
+#include <inet/optcom.h>
+#include <inet/tunables.h>
+
+#include <inet/dccp_stack.h>
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+#ifdef	_KERNEL
+
+#define	DCCP_MOD_ID		5999 /* XXX */
+
+extern struct qinit	dccp_sock_winit;
+extern struct qinit	dccp_winit;
+
+extern sock_downcalls_t	sock_dccp_downcalls;
+
+#define	DCCP_XMIT_LOWATER	(4 * 1024)
+#define	DCCP_XMIT_HIWATER	49152
+#define	DCCP_RECV_LOWATER	(2 * 1024)
+#define	DCCP_RECV_HIWATER	128000
+
+#define	TIDUSZ	4096	/* transport interface data unit size */
+
+/*
+ * Format arguments passed to dccp_display.
+ */
+#define	DISP_PORT_ONLY		1
+#define	DISP_ADDR_AND_PORT	2
+
+/*
+ * Bind hash array size and hash function.
+ */
+#define	DCCP_BIND_FANOUT_SIZE		128
+#define	DCCP_BIND_HASH(lport, size)	((ntohs((uint16_t)lport)) & (size - 1))
+
+/*
+ * Was this tcp created via socket() interface?
+ */
+#define	DCCP_IS_SOCKET(dccp)	((dccp)->dccp_issocket)
+
+/*
+ * Is this dccp not attached to any upper client?
+ */
+#define	DCCP_IS_DETACHED(dccp)	((dccp)->dccp_detached)
+
+/* Packet types (RFC 4340, Section 5.1.) */
+#define	DCCP_PKT_REQUEST	0
+#define	DCCP_PKT_RESPONSE	1
+#define	DCCP_PKT_DATA		2
+#define	DCCP_PKT_ACK		3
+#define	DCCP_PKT_DATAACK	4
+#define	DCCP_PKT_CLOSEREQ	5
+#define	DCCP_PKT_CLOSE		6
+#define	DCCP_PKT_RESET		7
+#define	DCCP_PKT_SYNC		8
+#define	DCCP_PKT_SYNCACK	9
+
+#define	DCCP_PACKET_REQUEST	0
+#define	DCCP_PACKET_RESPONSE	1
+#define	DCCP_PACKET_DATA	2
+#define	DCCP_PACKET_ACK		3
+#define	DCCP_PACKET_DATAACK	4
+#define	DCCP_PACKET_CLOSEREQ	5
+#define	DCCP_PACKET_CLOSE	6
+#define	DCCP_PACKET_RESET	7
+#define	DCCP_PACKET_SYNC	8
+#define	DCCP_PACKET_SYNCACK	9
+
+/*
+ * DCCP options and features.
+ */
+
+/*
+ * Options types (RFC 4340, Section 5.8.)
+ */
+#define	DCCP_OPTION_PADDING		0
+#define	DCCP_OPTION_MANDATORY		1
+#define	DCCP_OPTION_SLOW_RECEIVER	2
+#define	DCCP_OPTION_CHANGE_L		32
+#define	DCCP_OPTION_CONFIRM_L		33
+#define	DCCP_OPTION_CHANGE_R		34
+#define	DCCP_OPTION_CONFIRM_R		35
+#define	DCCP_OPTION_INIT_COOKIE		36
+#define	DCCP_OPTION_NDP_COUNT		37
+#define	DCCP_OPTION_ACK_VECTOR_1	38
+#define	DCCP_OPTION_ACK_VECTOR_2	39
+#define	DCCP_OPTION_DATA_DROPPED	40
+#define	DCCP_OPTION_TIMESTAMP		41
+#define	DCCP_OPTION_TIMESTAMP_ECHO	42
+#define	DCCP_OPTION_ELAPSED_TIME	43
+#define	DCCP_OPTION_DATA_CHECKSUM	44
+
+/*
+ * Feature types (RFC 4340, Section 6.4.)
+ */
+#define	DCCP_FEATURE_CCID			1
+#define	DCCP_FEATURE_ALLOW_SHORT_SEQNOS		2
+#define	DCCP_FEATURE_SEQUENCE_WINDOW		3
+#define	DCCP_FEATURE_ECN_INCAPABLE		4
+#define	DCCP_FEATURE_ACK_RATIO			5
+#define	DCCP_FEATURE_SEND_ACK_VECTOR		6
+#define	DCCP_FEATURE_SEND_NDP_COUNT		7
+#define	DCCP_FEATURE_MIN_CHECKSUM_COVERAGE	8
+#define	DCCP_FEATURE_CHECK_DATA_CHECKSUM	9
+
+/*
+ * Feature negotation states (RFC 4340, Section 6.6.2.)
+ */
+#define	DCCP_FEATURE_STATE_CHANGING		0
+#define	DCCP_FEATURE_STATE_UNSTABLE		1
+#define	DCCP_FEATURE_STATE_STABLE		2
+
+/*
+ * Reset types (RFC 4230, Section 5.6.)
+ */
+#define	DCCP_RESET_UNSPECIFIED			0
+#define	DCCP_RESET_CLOSED			1
+#define	DCCP_RESET_ABORTED			2
+#define	DCCP_RESET_NO_CONNECTION		3
+#define	DCCP_RESET_PACKET_ERROR			4
+#define	DCCP_RESET_OPTION_ERROR			5
+#define	DCCP_RESET_MANDATORY_ERROR		6
+#define	DCCP_RESET_CONNECTION_REFUSED		7
+#define	DCCP_RESET_BAD_SERVICE_CODE		8
+#define	DCCP_RESET_TOO_BUSY			9
+#define	DCCP_RESET_BAD_INIT_COOKIE		10
+#define	DCCP_RESET_AGGRESSION_PENALTY		11
+#define	DCCP_RESET_RESERVED			12
+
+typedef struct dccp_feature_s {
+	list_node_t	df_next;
+	uint8_t		df_option;
+	uint8_t		df_type;
+	uint8_t		df_state;
+	uint64_t	df_value;
+	boolean_t	df_mandatory;
+} dccp_feature_t;
+
+/* Options in DCCP header */
+typedef struct dccp_opt_s {
+	int		type;
+	boolean_t	mandatory;
+} dccp_opt_t;
+
+/*
+ * Tuneables.
+ */
+#define	dccps_smallest_nonpriv_port	dccps_propinfo_tbl[0].prop_cur_uval
+#define	dccps_smallest_anon_port	dccps_propinfo_tbl[1].prop_cur_uval
+#define	dccps_largest_anon_port		dccps_propinfo_tbl[2].prop_cur_uval
+
+#define	dccps_dbg			dccps_propinfo_tbl[4].prop_cur_uval
+#define	dccps_rst_sent_rate_enabled	dccps_propinfo_tbl[5].prop_cur_uval
+#define	dccps_rst_sent_rate		dccps_propinfo_tbl[6].prop_cur_uval
+
+#define	dccps_ip_abort_cinterval	dccps_propinfo_tbl[7].prop_cur_uval
+#define	dccps_ip_abort_linterval	dccps_propinfo_tbl[8].prop_cur_uval
+#define	dccps_ip_abort_interval		dccps_propinfo_tbl[9].prop_cur_uval
+#define	dccps_ip_notify_cinterval	dccps_propinfo_tbl[10].prop_cur_uval
+#define	dccps_ip_notify_interval	dccps_propinfo_tbl[11].prop_cur_uval
+#define	dccps_keepalive_interval_high	dccps_propinfo_tbl[12].prop_max_uval
+#define	dccps_keepalive_interval	dccps_propinfo_tbl[12].prop_cur_uval
+#define	dccps_keepalive_interval_low	dccps_propinfo_tbl[12].prop_min_uval
+#define	dccps_keepalive_abort_interval_high \
+					dccps_propinfo_tbl[13].prop_max_uval
+#define	dccps_keepalive_abort_interval	dccps_propinfo_tbl[13].prop_cur_uval
+#define	dccps_keepalive_abort_interval_low \
+					dccps_propinfo_tbl[13].prop_min_uval
+
+/*
+ * Timers.
+ */
+typedef struct dccp_timer_s {
+	conn_t	*connp;
+	void	(*dccpt_proc)(void *);
+	callout_id_t	dccpt_tid;
+} dccp_timer_t;
+
+extern kmem_cache_t	*dccp_timercache;
+
+#define	DCCP_TIMER(dccp, f, tim)	\
+	dccp_timeout(dccp->dccp_connp, f, tim)
+
+#define	DCCP_TIMER_CANCEL(dccp, id)	\
+	dccp_timeout_cancel(dccp->dccp_connp, id)
+
+#define	DCCP_TIMER_RESTART(dccp, intvl) {			\
+	if ((dccp)->dccp_timer_tid != 0)			\
+		(void) DCCP_TIMER_CANCEL((dccp), (dccp)->dccp_timer_tid); \
+	(dccp)->dccp_timer_tid = DCCP_TIMER((dccp), dccp_timer, (intvl)); \
+}
+
+extern struct qinit	dccp_rinitv4, dccp_rinitv6;
+
+extern optdb_obj_t	dccp_opt_obj;
+extern uint_t		dccp_max_optsize;
+
+extern int		dccp_squeue_flag;
+
+/*
+ * Functions in dccp.c
+ */
+extern int	dccp_build_hdrs(dccp_t *);
+extern conn_t	*dccp_create_common(cred_t *, boolean_t, boolean_t, int *);
+extern void	dccp_close_common(conn_t *, int);
+extern int	dccp_do_bind(conn_t *, struct sockaddr *, socklen_t, cred_t *,
+		    boolean_t);
+extern int	dccp_do_unbind(conn_t *);
+extern int	dccp_do_listen(conn_t *, struct sockaddr *, socklen_t, int,
+		    cred_t *, boolean_t);
+extern int	dccp_do_connect(conn_t *, const struct sockaddr *, socklen_t,
+		    cred_t *, pid_t);
+extern void	dccp_init_values(dccp_t *, dccp_t *);
+extern void	dccp_free(dccp_t *);
+extern void	*dccp_get_conn(void *, dccp_stack_t *);
+extern void	dccp_get_proto_props(dccp_t *, struct sock_proto_props *);
+extern int	dccp_set_destination(dccp_t *);
+extern int	dccp_clean_death(dccp_t *, int);
+
+
+/*
+ * Functions in dccp_bind.c
+ */
+extern void	dccp_bind_hash_insert(dccp_df_t *, dccp_t *, int);
+extern void	dccp_bind_hash_remove(dccp_t *);
+extern int	dccp_bind_check(conn_t *, struct sockaddr *, socklen_t,
+		    cred_t *cr, boolean_t);
+extern in_port_t dccp_bindi(dccp_t *, in_port_t, const in6_addr_t *, int,
+		    boolean_t, boolean_t, boolean_t);
+extern in_port_t dccp_update_next_port(in_port_t, const dccp_t *, boolean_t);
+
+/*
+ * Functions in dccp_features.c
+ */
+extern int	dccp_parse_feature(dccp_t *, uint8_t, uint8_t, uchar_t *,
+		    boolean_t);
+
+/*
+ * Functions in dccp_stats.c
+ */
+extern mblk_t	*dccp_snmp_get(queue_t *, mblk_t *, boolean_t);
+extern void	*dccp_kstat_init(netstackid_t);
+extern void	dccp_kstat_fini(netstackid_t, kstat_t *);
+extern void	*dccp_kstat2_init(netstackid_t);
+extern void	dccp_kstat2_fini(netstackid_t, kstat_t *);
+
+/*
+ * Functions in dccp_socket.c
+ */
+extern sock_lower_handle_t	dccp_create(int, int, int, sock_downcalls_t **,
+				    uint_t *, int *, int, cred_t *);
+extern int	dccp_fallback(sock_lower_handle_t, queue_t *, boolean_t,
+		    so_proto_quiesced_cb_t, sock_quiesce_arg_t *);
+extern boolean_t	dccp_newconn_notify(dccp_t *, ip_recv_attr_t *);
+
+/*
+ * Functions in dccp_input.c
+ */
+extern void	dccp_icmp_input(void *, mblk_t *, void *, ip_recv_attr_t *);
+extern void	dccp_input_data(void *, mblk_t *, void *, ip_recv_attr_t *);
+extern void	dccp_rsrv(queue_t *);
+extern void	dccp_input_listener_unbound(void *, mblk_t *, void *,
+		    ip_recv_attr_t *);
+extern boolean_t dccp_verifyicmp(conn_t *, void *, icmph_t *, icmp6_t *,
+		    ip_recv_attr_t *);
+
+/*
+ * Functions in dccp_misc.c
+ */
+extern void	dccp_stack_cpu_add(dccp_stack_t *, processorid_t);
+extern char	*dccp_display(dccp_t *, char *, char);
+
+/*
+ * Functions in dccp_options.c
+ */
+extern int	dccp_parse_options(dccp_t *, dccpha_t *);
+extern int	dccp_process_options(dccp_t *, dccpha_t *);
+extern int	dccp_generate_options(dccp_t *, void **, size_t *);
+
+/*
+ * Functions in dccp_output.c
+ */
+extern void	dccp_wput(queue_t *, mblk_t *);
+extern void	dccp_wput_data(dccp_t *, mblk_t *, boolean_t);
+extern void	dccp_wput_sock(queue_t *, mblk_t *);
+extern void	dccp_wput_fallback(queue_t *, mblk_t *);
+extern void	dccp_output(void *, mblk_t *, void *, ip_recv_attr_t *);
+extern void	dccp_output_urgent(void *, mblk_t *, void *, ip_recv_attr_t *);
+extern void	dccp_close_output(void *, mblk_t *, void *, ip_recv_attr_t *);
+extern void	dccp_shutdown_output(void *, mblk_t *, void *, ip_recv_attr_t *);
+extern void	dccp_send_data(dccp_t *, mblk_t *);
+extern void	dccp_xmit_listeners_reset(mblk_t *, ip_recv_attr_t *,
+		    ip_stack_t *, conn_t *);
+extern void	dccp_send_synack(void *, mblk_t *, void *, ip_recv_attr_t *);
+extern mblk_t	*dccp_xmit_mp(dccp_t *, mblk_t *, int32_t, int32_t *,
+		    mblk_t **, uint32_t, boolean_t, uint32_t *, boolean_t);
+/* XXX following functions should be redone */
+extern mblk_t	*dccp_generate_response(conn_t *, mblk_t *);
+extern mblk_t	*dccp_generate_request(conn_t *);
+extern mblk_t	*dccp_generate_reset(conn_t *);
+extern mblk_t	*dccp_generate_ack(conn_t *);
+extern mblk_t	*dccp_generate_sync(conn_t *);
+
+/*
+ * Functions in dccp_opt_data.c
+ */
+extern int	dccp_opt_get(conn_t *, int, int, uchar_t *);
+extern int	dccp_opt_set(conn_t *, uint_t, int, int, uint_t, uchar_t *,
+		    uint_t *, uchar_t *, void *, cred_t *);
+
+/*
+ * Functions in dccp_timers.c
+ */
+extern timeout_id_t	dccp_timeout(conn_t *, void (*)(void *), hrtime_t);
+extern clock_t	dccp_timeout_cancel(conn_t *, timeout_id_t);
+extern mblk_t	*dccp_timermp_alloc(int);
+extern void	dccp_timermp_free(dccp_t *);
+extern void	dccp_timers_stop(dccp_t *);
+extern void	dccp_keepalive_timer(void *);
+extern void	dccp_timer(void *);
+
+/*
+ * Functions in dccp_tpi.c
+ */
+extern void	dccp_do_capability_ack(dccp_t *, struct T_capability_ack *,
+		    t_uscalar_t);
+extern void	dccp_capability_req(dccp_t *, mblk_t *);
+extern void	dccp_err_ack(dccp_t *, mblk_t *, int, int);
+extern void	dccp_tpi_connect(dccp_t *, mblk_t *);
+extern int	dccp_tpi_close(queue_t *, int);
+extern int	dccp_tpi_close_accept(queue_t *);
+extern boolean_t	dccp_conn_con(dccp_t *, uchar_t *, mblk_t *, mblk_t **,
+			    ip_recv_attr_t *);
+extern int	dccp_tpi_opt_get(queue_t *, t_scalar_t, t_scalar_t, uchar_t *);
+extern int	dccp_tpi_opt_set(queue_t *, uint_t, int, int, uint_t, uchar_t *,
+		    uint_t *, uchar_t *, void *, cred_t *);
+extern void	dccp_tpi_accept(queue_t *, mblk_t *);
+
+#endif	/* _KERNEL */
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _INET_DCCP_IMPL_H */
--- /dev/null	2012-08-18 10:37:12.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp_ip.h	2012-08-18 10:37:12.137961758 +0000
@@ -0,0 +1,37 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner. All rights reserved.
+ */
+
+#ifndef	_INET_DCCP_DCCP_IP_H
+#define	_INET_DCCP_DCCP_IP_H
+
+#include <netinet/dccp.h>
+#include <inet/dccp_stack.h>
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+/*
+ * DCCP functions for IP
+ */
+extern void	dccp_ddi_g_init(void);
+extern void	dccp_ddi_g_destroy(void);
+
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _INET_DCCP_DCCP_IP_H */
--- /dev/null	2012-08-18 10:37:12.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp_stack.h	2012-08-18 10:37:12.322788998 +0000
@@ -0,0 +1,73 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner.  All rights reserved.
+ */
+
+#ifndef	_INET_DCCP_DCCP_STACK_H
+#define	_INET_DCCP_DCCP_STACK_H
+
+#include <sys/netstack.h>
+#include <sys/cpuvar.h>
+#include <sys/sunddi.h>
+#include <sys/sunldi.h>
+#include <inet/ip.h>
+#include <inet/ipdrop.h>
+#include <inet/dccp_stats.h>
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+/*
+ * DCCP stack instances
+ */
+typedef struct dccp_stack {
+	netstack_t		*dccps_netstack;	/* Common netstack */
+
+	uint_t			dccps_bind_fanout_size;
+	struct dccp_df_s	*dccps_bind_fanout;
+
+	/*
+	 * Privileged ports.
+	 */
+#define	DCCP_NUM_EPRIV_PORTS	64
+	int			dccps_num_epriv_ports;
+	in_port_t		dccps_epriv_ports[DCCP_NUM_EPRIV_PORTS];
+	kmutex_t		dccps_epriv_port_lock;
+
+	in_port_t		dccps_min_anonpriv_port;
+	uint_t			dccps_next_port_to_try;
+
+	/* Reset rate control */
+	int64_t			dccps_last_rst_intrvl;
+	uint32_t		dccps_rst_cnt;
+
+	/* Tunables table */
+	struct mod_prop_info_s	*dccps_propinfo_tbl;
+
+	ldi_ident_t		dccps_ldi_ident;
+
+	/* MIB-II kernel statistics */
+	kstat_t			*dccps_mibkp;
+	kstat_t			*dccps_kstat;
+
+	/* CPU stats counter */
+	dccp_stats_cpu_t	**dccps_sc;
+	int			dccps_sc_cnt;
+} dccp_stack_t;
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _INET_DCCP_DCCP_STACK_H */
--- /dev/null	2012-08-18 10:37:12.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp_stats.h	2012-08-18 10:37:12.487495513 +0000
@@ -0,0 +1,61 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner.  All rights reserved.
+ */
+
+#ifndef	_INET_DCCP_DCCP_STATS_H
+#define	_INET_DCCP_DCCP_STATS_H
+
+#include <sys/netstack.h>
+#include <sys/cpuvar.h>
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+/* Kstats */
+typedef struct dccp_stat {
+	kstat_named_t	dccp_sock_fallback;
+} dccp_stat_t;
+
+typedef struct dccp_stat_counter_s {
+	uint64_t	dccp_no_listener;
+	uint64_t	dccp_listendrop;
+	uint64_t	dccp_wsrv_called;
+	uint64_t	dccp_sock_fallback;
+	uint64_t	dccp_rst_unsent;
+} dccp_stat_counter_t;
+
+typedef struct {
+	uint64_t		dccp_stats_cnt;
+	mib2_dccp_t		dccp_sc_mib;
+	dccp_stat_counter_t	dccp_sc_stats;
+} dccp_stats_cpu_t;
+
+/*
+ * MIB-II
+ */
+#define	DCCPS_BUMP_MIB(dccps, x) \
+	BUMP_MIB(&(dccps)->dccps_sc[CPU->cpu_seqid]->dccp_sc_mib, x)
+
+#define	DCCPS_UPDATE_MIB(dccps, x, y) \
+	UPDATE_MIB(&(dccps)->dccps_sc[CPU->cpu_seqid]->dccp_sc_mib, x, y)
+
+#define	DCCP_STAT(dccps, x)	\
+	((dccps)->dccps_sc[CPU->cpu_seqid]->dccp_sc_stats.x++)
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _INET_DCCP_DCCP_STATS_H */
